/*
 * Author:   (, 3, ..:80527)
 *
 *  ( 8)
 *  1
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
      char name[100];
      int age;
} Person;

void swap(Person*, int, int);

int main() {
	int counter = 0;
	int i, j;
	Person* people = NULL;

	FILE* file = fopen("prob1.in.txt", "r");
	// Error handler
	if(file == NULL) {
		printf("Error opening file!\n");
		exit(EXIT_FAILURE);
	}

	// Read and copy
	while (!feof(file)) {
		counter++;
		people = (Person*)realloc(people, sizeof(Person)*counter);
		if (people == NULL) {
			printf("Allocation failed!\n");
			exit(EXIT_FAILURE);
		}
		fscanf(file, "%s %d\n", people[counter-1].name, &people[counter-1].age);
	}
	fclose(file);

	// Sort by age
	for(i = 0; i < (counter-1); i++)
		for(j = i; j < counter; j++)
			if(people[i].age > people[j].age)
				swap(people, i, j);

	// Sort by name
	for(i = 0; i < (counter-1); i++)
		for(j = i; j < counter; j++)
			if(people[i].age == people[j].age)
				if(strcmp(people[i].name, people[j].name) < 0)
					 swap(people, i, j);
	
	// Output
	for (i = 0; i < counter; i++)
		printf ("%s - %d\n", people[i].name, people[i].age);

	// Write
	FILE* new_file = fopen("prob1.out.txt", "w");
	for (i = 0; i < counter; i++)
		fprintf(new_file, "%s %d\n", people[i].name, people[i].age);
	fclose(new_file);

	/*for(int i = 0; i < counter; i++)
		free(&people[i]);*/
	free(people);

	system("pause");
	return 0;
}

void swap(Person* people, int from, int to) {
	char tmp_name[100];
	int tmp_age;

	tmp_age = people[from].age;
	strcpy(tmp_name, people[from].name);

	people[from].age = people[to].age;
	strcpy(people[from].name, people[to].name);

	people[to].age = tmp_age;
	strcpy(people[to].name, tmp_name);
}